package cn.ibizlab.r7.runtime.service.runtimemgr.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.core.r7rt_base.valuerule.anno.usergroup.*;
import cn.ibizlab.r7.runtime.core.r7rt_base.domain.UserGroup;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[UserGroupDTO]
 */
public class UserGroupDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @UserGroupUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @UserGroupUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [MEMO]
     *
     */
    @UserGroupMemoDefault(info = "默认规则")
    private String memo;

    @JsonIgnore
    private boolean memoDirtyFlag;

    /**
     * 属性 [USEROBJECTTYPE]
     *
     */
    @UserGroupUserObjectTypeDefault(info = "默认规则")
    private String userObjectType;

    @JsonIgnore
    private boolean userObjectTypeDirtyFlag;

    /**
     * 属性 [DATASOURCETYPE]
     *
     */
    @UserGroupDataSourceTypeDefault(info = "默认规则")
    private String dataSourceType;

    @JsonIgnore
    private boolean dataSourceTypeDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @UserGroupCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @UserGroupCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [USERGROUPNAME]
     *
     */
    @UserGroupUserGroupNameDefault(info = "默认规则")
    private String userGroupName;

    @JsonIgnore
    private boolean userGroupNameDirtyFlag;

    /**
     * 属性 [ENABLE]
     *
     */
    @UserGroupEnableDefault(info = "默认规则")
    private Integer enable;

    @JsonIgnore
    private boolean enableDirtyFlag;

    /**
     * 属性 [USERGROUPID]
     *
     */
    @UserGroupUserGroupIdDefault(info = "默认规则")
    private String userGroupId;

    @JsonIgnore
    private boolean userGroupIdDirtyFlag;


    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [MEMO]
     */
    @JsonProperty("memo")
    public String getMemo(){
        return memo ;
    }

    /**
     * 设置 [MEMO]
     */
    @JsonProperty("memo")
    public void setMemo(String  memo){
        this.memo = memo ;
        this.memoDirtyFlag = true ;
    }

    /**
     * 获取 [MEMO]脏标记
     */
    @JsonIgnore
    public boolean getMemoDirtyFlag(){
        return memoDirtyFlag ;
    }

    /**
     * 获取 [USEROBJECTTYPE]
     */
    @JsonProperty("userobjecttype")
    public String getUserObjectType(){
        return userObjectType ;
    }

    /**
     * 设置 [USEROBJECTTYPE]
     */
    @JsonProperty("userobjecttype")
    public void setUserObjectType(String  userObjectType){
        this.userObjectType = userObjectType ;
        this.userObjectTypeDirtyFlag = true ;
    }

    /**
     * 获取 [USEROBJECTTYPE]脏标记
     */
    @JsonIgnore
    public boolean getUserObjectTypeDirtyFlag(){
        return userObjectTypeDirtyFlag ;
    }

    /**
     * 获取 [DATASOURCETYPE]
     */
    @JsonProperty("datasourcetype")
    public String getDataSourceType(){
        return dataSourceType ;
    }

    /**
     * 设置 [DATASOURCETYPE]
     */
    @JsonProperty("datasourcetype")
    public void setDataSourceType(String  dataSourceType){
        this.dataSourceType = dataSourceType ;
        this.dataSourceTypeDirtyFlag = true ;
    }

    /**
     * 获取 [DATASOURCETYPE]脏标记
     */
    @JsonIgnore
    public boolean getDataSourceTypeDirtyFlag(){
        return dataSourceTypeDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [USERGROUPNAME]
     */
    @JsonProperty("usergroupname")
    public String getUserGroupName(){
        return userGroupName ;
    }

    /**
     * 设置 [USERGROUPNAME]
     */
    @JsonProperty("usergroupname")
    public void setUserGroupName(String  userGroupName){
        this.userGroupName = userGroupName ;
        this.userGroupNameDirtyFlag = true ;
    }

    /**
     * 获取 [USERGROUPNAME]脏标记
     */
    @JsonIgnore
    public boolean getUserGroupNameDirtyFlag(){
        return userGroupNameDirtyFlag ;
    }

    /**
     * 获取 [ENABLE]
     */
    @JsonProperty("enable")
    public Integer getEnable(){
        return enable ;
    }

    /**
     * 设置 [ENABLE]
     */
    @JsonProperty("enable")
    public void setEnable(Integer  enable){
        this.enable = enable ;
        this.enableDirtyFlag = true ;
    }

    /**
     * 获取 [ENABLE]脏标记
     */
    @JsonIgnore
    public boolean getEnableDirtyFlag(){
        return enableDirtyFlag ;
    }

    /**
     * 获取 [USERGROUPID]
     */
    @JsonProperty("usergroupid")
    public String getUserGroupId(){
        return userGroupId ;
    }

    /**
     * 设置 [USERGROUPID]
     */
    @JsonProperty("usergroupid")
    public void setUserGroupId(String  userGroupId){
        this.userGroupId = userGroupId ;
        this.userGroupIdDirtyFlag = true ;
    }

    /**
     * 获取 [USERGROUPID]脏标记
     */
    @JsonIgnore
    public boolean getUserGroupIdDirtyFlag(){
        return userGroupIdDirtyFlag ;
    }



    public UserGroup toDO() {
        UserGroup srfdomain = new UserGroup();
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getMemoDirtyFlag())
            srfdomain.setMemo(memo);
        if(getUserObjectTypeDirtyFlag())
            srfdomain.setUserObjectType(userObjectType);
        if(getDataSourceTypeDirtyFlag())
            srfdomain.setDataSourceType(dataSourceType);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getUserGroupNameDirtyFlag())
            srfdomain.setUserGroupName(userGroupName);
        if(getEnableDirtyFlag())
            srfdomain.setEnable(enable);
        if(getUserGroupIdDirtyFlag())
            srfdomain.setUserGroupId(userGroupId);

        return srfdomain;
    }

    public void fromDO(UserGroup srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getMemoDirtyFlag())
            this.setMemo(srfdomain.getMemo());
        if(srfdomain.getUserObjectTypeDirtyFlag())
            this.setUserObjectType(srfdomain.getUserObjectType());
        if(srfdomain.getDataSourceTypeDirtyFlag())
            this.setDataSourceType(srfdomain.getDataSourceType());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getUserGroupNameDirtyFlag())
            this.setUserGroupName(srfdomain.getUserGroupName());
        if(srfdomain.getEnableDirtyFlag())
            this.setEnable(srfdomain.getEnable());
        if(srfdomain.getUserGroupIdDirtyFlag())
            this.setUserGroupId(srfdomain.getUserGroupId());

    }

    public List<UserGroupDTO> fromDOPage(List<UserGroup> poPage)   {
        if(poPage == null)
            return null;
        List<UserGroupDTO> dtos=new ArrayList<UserGroupDTO>();
        for(UserGroup domain : poPage) {
            UserGroupDTO dto = new UserGroupDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

